-------------------------------------------------------------------------------
--|> KOS
--: Kill On Sight player tracking, notifications and visual indicators
-------------------------------------------------------------------------------
--|> INIT
-------------------------------------------------------------------------------
local _, NS = ...
NS.KOS = {}
local KOS = NS.KOS

--> KOS CORE FUNCTINONS
-------------------------------------------------------------------------------
function KOS.ClearStoredList()
    wipe(NS.KosList)
end

--> KOS EVENTS
-------------------------------------------------------------------------------
KOS.Events = CreateFrame("Frame", "weizPVP-KOS Event Frame", UIParent)
KOS.Events:SetPoint("CENTER")
KOS.Events:SetSize(32, 32)
KOS.Events:Hide()

--=> OnEvent
-------------------------------------------------------
KOS.Events:SetScript(
    "OnEvent",
    function(self, event, ...)
        return self[event] and self[event](self, ...)
    end
)

--=> Enable
-------------------------------------------------------
function NS.KOS.Enable()
    KOS.Events:RegisterEvent("PLAYER_TARGET_CHANGED")
    KOS.Events:RegisterEvent("GLOBAL_MOUSE_UP")
end

--=> Disable
-------------------------------------------------------
function NS.KOS.Disable()
    KOS.Events:UnregisterEvent("PLAYER_TARGET_CHANGED")
    KOS.Events:UnregisterEvent("GLOBAL_MOUSE_UP")
end

--> AddPlayer
-------------------------------------------------------
function KOS.AddPlayer(playerName)
    if not playerName then
        return
    end
    --> Add player to KOS list and refresh the core player list
    NS.KosList[playerName] = true
    NS.SortNearbyList()
    NS.RefreshCurrentList()
    --> Refresh Crosshair is targeting the added player
    if (NS.GetUnitName("target") == playerName) and NS.Options.Crosshair.Enabled then
        NS.Crosshair.Reset()
        NS.Crosshair.NewTarget()
    end
end

--> RemovePlayer
-------------------------------------------------------
function KOS.RemovePlayer(playerName)
    --> Remove from KOS list and refresh list
    NS.KosList[playerName] = nil
    NS.SortNearbyList()
    NS.RefreshCurrentList()
    --> Refresh Crosshair is targeting the added player
    if (NS.GetUnitName("target") == playerName) and NS.Options.Crosshair.Enabled then
        NS.Crosshair.Reset()
        NS.Crosshair.NewTarget()
    end
end
