local _, NS = ...
local menuPlayerName
local menuPlayerGUID
local classColoredPlayerName
local XEN = XEN
local RAID_CLASS_COLORS = RAID_CLASS_COLORS

function NS.KOS.ChangeKosStatus(playerName)
    if not playerName then
        return
    end
    menuPlayerName = XEN.Unescape(playerName)
    if NS.KosList[menuPlayerName] then
        NS.KOS.RemovePlayer(menuPlayerName)
        NS.PrintAddonMessage("|TInterface\\Addons\\weizPVP\\Addons\\KOS\\Media\\kos_icon.tga:0|t |cff8fdaffRemoved|r |cff666666:|r " .. playerName)
    elseif menuPlayerName then
        NS.KOS.AddPlayer(menuPlayerName)
        if NS.GetUnitName("target") == menuPlayerName then
            NS.Crosshair.Reset()
            NS.Crosshair.NewTarget()
        end
        --> Addon Message
        NS.PrintAddonMessage("|TInterface\\Addons\\weizPVP\\Addons\\KOS\\Media\\kos_icon.tga:0|t |cff8fdaffAdded|r |cff666666:|r " .. playerName)
    end
    NS.RefreshCurrentList()
end

local function menuText()
    return NS.KosList[menuPlayerName] and
        "|TInterface\\Addons\\weizPVP\\Addons\\KOS\\Media\\kos_icon_remove.tga:0|t |cff8fdaffRemove from|r |cffff0037KOS|r" or
        "|TInterface\\Addons\\weizPVP\\Addons\\KOS\\Media\\kos_icon_add.tga:0|t |cff8fdaffAdd to|r |cffff0037KOS|r"
end

local infoName = {}
local infoKosToggle = {}
function weizPVP_PlayerBarMenu.OnLoad()
    local cache = NS.PlayerActiveCache[menuPlayerGUID]
    if not cache then
        return
    end
    classColoredPlayerName = "|c" .. RAID_CLASS_COLORS[cache.Class].colorStr .. menuPlayerName .. "|r" --class colored formatted string
    --> NAME
    infoName = {}
    infoName.text = classColoredPlayerName
    infoName.notCheckable = 1
    infoName.notClickable = 1
    infoName.padding = 0
    infoName.leftPadding = 0
    UIDropDownMenu_AddButton(infoName)
    --> KOS TOGGLE
    infoKosToggle = {}
    infoKosToggle.text = menuText()
    infoKosToggle.notCheckable = 1
    infoKosToggle.padding = 0
    infoKosToggle.leftPadding = 0
    infoKosToggle.func = function()
        NS.KOS.ChangeKosStatus(classColoredPlayerName)
    end
    UIDropDownMenu_AddButton(infoKosToggle)
end

function NS.KOS.PlayerBarMenu_OnClick(bar)
    if not bar then
        return
    end
    menuPlayerName = bar.name
    menuPlayerGUID = bar.GUID
    ToggleDropDownMenu(1, nil, weizPVP_PlayerBarMenu, "cursor", 0, 0)
end
